--[[
Kill Notifications v1.4
by Kierky.

Version 1.5.3 Synced list with Sonara's findings. Added 2 weapons. Thanks Sonara!
Version 1.5.2 Added a few weapons.
Version 1.5.1 Removed depreciated plugin checks
Version 1.5 fixed a few edge cases and added caprails.
Version 1.4.2 bugfixes
Version 1.4.1 Trident boom added.
Version 1.4 Fixed improper handling of bots
Version 1.3 Fixed the out of sector kill notifications.
Version 1.2.1/2/3: fixed %player% is having issues bug/minor ctc bot kill bug & color bug
Version 1.2: Added colourisation to player kills, and dulled bot kills.
Versions 1.0 and 1.1 were stabilisers, testing alphas, initial versions

--]]

-- Declare
kill = {}
kill.version = "1.4"
kill.record = {}
kill.event = {}
kill.notifier = {}
kill.togglenotify = {}

local weaponbase = {
                [0]="Self Destruct",
                [18]="Ion Blaster",
                [20]="Ion Blaster MkII",
                [22]="Ion Blaster MkIII",
                [24]="Phase Blaster",
                [26]="Phase Blaster MkII",
                [28]="Orion Phase Blaster XGX",
                [32]="Neutron Blaster",
                [34]="Neutron Blaster Mk II",
                [36]="Neutron Blaster MkIII",
                [30]="TPG Sparrow Phase Blaster",
                [40]="Corvus Widowmaker",
                [42]="Positron Blaster",
                [44]="AAP",
                [46]="Mega Positron",
                [48]="LENB",
                [54] = "Capital Turret Cannon",
                [56]="Capital Gauss",
                [67]="Charged Cannon",
                [84]="Iceflare",
                [86]="Starflare",
                [87]="Fletchette Cannon",
                [89]="Fletchette Cannon MkII",
                [91]="Gov't Plasma Cannon",
                [97]="Gatling Cannon",
                [99]="Gatling Cannon MkII",
                [103]="Gauss Cannon",
                [105]="Gauss Cannon MkII",
                [108]="Gemini Missile",
                [114]="Plasma Cannon MkII",
                [116]="Plasma Cannon MkIII",
                [118]="Plasma Cannon HX",
                [121]="Lightning Mine",
                [124]="Proximity Mine",
                [128]="Tellar Ulam Mine",
                [134]="YellowJacket Missile",
                [136]="Stingray Missile",
                [138]="Firefly Missile",
                [140]="Super-Capital Missile Turret",
                [145]="Plasma Devastator",
                [147]="Plasma Devastator MkII",
                [150]="Hive Positron Blaster",
                [152]="Hive Gatling Cannon",
                [156]="Rail Gun",
                [158]="Rail Gun MkII",
                [160]="Rail Gun MkIII",
                [162]="Advanced Rail Gun",
                [173]="Sunflare",
                [175]="Jackhammer Rocket",
                [177]="Screamer Rocket",
                [179]="Avalon Torpedo",
                [183]="Seeker Missile",
                [188]="Capital Gauss",
                [191]="Hull Explosion",
                [192]="Hyper-Plasma Detonation",
                [193]="Aerna Explosives",
                [198]="Locust Swarm Missile",
                [200]="Chaos Swarm",
                [202]="Capital Swarm Missile Launcher", ---------
                [213]="Gatling Turret",
                [409]="Unknown Weapon ID[409]",
                [702]="Raven",
                [704]="Plasma Eliminator MkII",
                [706]="Plasma Annihilator",
                [708]="Plasma Eliminator",
                [711]="Gauss Cannon MkIII",
                [716]="Training Blaster",
                [718]="Collision",
                [735]="Gauss Cannon MkII - Turret",
                [742]="Capital Missile Turret",
                [747]="Firecracker Missile",
                [788]="Gemini Missile Turret",
                [789]="Gatling Cannon HV",
                [807]="Capital Gauss Cannon - Turret",
                [810]="Capital Swarm Turret",
                [921]="Capital Rail Cannon",
				[928]="Corvus UltraPosi",

}

-- Variables
kill_notify_mode = true
--Colours
local red= "\127ff1010"
local white= "\127ffffff"
local green= "\12700cf10"
local blue= "\1270078ff"
local yellow= "\127cccc00"
local grey= "\127afafaf"
local customcolour1 = "\127ffffff"
local customcolour2 = "\127ffffff"
local customcolour3 = "\127ffffff"
local endcolour = "\127o"
-- Functions
function printmsg(colour, message)
	print(colour .. message .. endcolour)
end

function kill.togglenotify()
	if kill_notify_mode == true then
		kill_notify_mode = false
		printmsg(red,'Notify Mode Off')
	else
		kill_notify_mode = true
		printmsg(green,'Notify Mode On!')
	end
end

function kill.GetWeapon(number)
	local weapon = nil
	if weaponbase[number] ~= nil then
		weapon = weaponbase[number]
	else
		weapon = "Weapon Not Recorded: " .. number
	end
	return weapon
end

function kill.event:OnEvent(event, deadguy, killer, weapon, loc)
	local killerchar = GetPlayerName(killer)
	local deadchar = GetPlayerName(deadguy)
	local weaponused = kill.GetWeapon(weapon)
	local killerfaction = GetPlayerFaction(killer)
	local deadguyfaction = GetPlayerFaction(deadguy)
	local location = ShortLocationStr(loc) or ""
	local bot = true
	if ((string.sub(deadchar, 1, 1)~="*") and (string.sub(killerchar, 1, 1)~="*")) then
		-- if not a bot, do
		bot = false
		if killerfaction == 1 then customcolour1 = blue elseif killerfaction == 2 then customcolour1 = red else customcolour1 = yellow end
		if deadguyfaction == 1 then customcolour2 = blue elseif deadguyfaction == 2 then customcolour2 = red else customcolour2 = yellow end
		if killer == GetCharacterID() then customcolour3 = green else customcolour3 = red end
	else
		customcolour1 = grey 
		customcolour2 = grey
		customcolour3 = grey
		-- this is a bot, play the death of the bot down
	end
	-- create different msgs
	local oldmsg = killerchar .. " destroyed " .. deadchar
	local issuesmsg = customcolour1 .. killerchar .. endcolour .. " killed themselves with " .. customcolour3 .. weaponused .. endcolour
	local prettymsg = ""
	local strippedmsg = ""
	if location == "" then
		strippedmsg = killerchar .. " destroyed " .. deadchar .. " with " .. weaponused
		prettymsg = customcolour1 .. killerchar .. endcolour .. " destroyed " .. customcolour2 .. deadchar .. endcolour .. " with " .. customcolour3 .. weaponused .. endcolour
	elseif location ~= "" then
		strippedmsg = killerchar .. " destroyed " .. deadchar .. " with " .. weaponused .. " in " .. location
		prettymsg = customcolour1 .. killerchar .. endcolour .. " destroyed " .. customcolour2 .. deadchar .. endcolour .. " with " .. customcolour3 .. weaponused .. endcolour .. " in " .. location
	end
	-- This piece of logic not only controls what kind of message prints, but also whether the plugin information is used at all due to state toggles.
	if (kill_notify_mode == true and (killer ~= deadguy)) then
		printmsg(white,prettymsg)
	elseif (kill_notify_mode == true and (killer == deadguy)) then
		printmsg(white,issuesmsg)
	else
		chatreceiver:OnEvent("CHAT_MSG_DEATH", {msg=oldmsg})
	end
end
-- Events
RegisterEvent(kill.event, "PLAYER_DIED")
-- This is necessary to stop the system message from duplicating our one.
UnregisterEvent(chatreceiver, "CHAT_MSG_DEATH")

-- User Commands 
RegisterUserCommand("notify", kill.togglenotify)